/*
 * primer.c
 *
 *  Created on: May 03, 2016
 *      Author: Vangel V. Ajanovski
 */

#include <stdio.h>
#include <GL/glut.h>
#include <math.h>

#include "utils.h"

const int chekor = 9;
float agolX = 0;
float agolY = 0;
float agolZ = 0;
float transZ = 50;
float rotateA = 0;
float rotateAspeed = 0.0f;
float rotateNasa = 70.0f;
int polygonMode = GL_FILL;
float alpha = 1.0f;
float shadowAlpha = 0.5f;
float svX = -5, svY = 48, svZ = -30;

static GLuint texKilim;
static GLuint texAluminium;
static GLuint texNASA;
static GLuint texDrvo;
static GLuint texParket;

static GLuint selPatos = 0;
static GLuint selTavan = 1;
static GLuint selLev = 2;
static GLuint selDesen = 3;
static GLuint selPozadi = 4;
static GLuint selMural = 5;
static GLuint selSkalila1 = 6;
static GLuint selSkalila2 = 7;
static GLuint selSkalila3 = 8;
static GLuint selSkalila4 = 9;
static GLuint selStolb1 = 10;
static GLuint selStolb2 = 11;
static GLuint selStolb3 = 12;
static GLuint selStolb4 = 13;
static GLuint selKilim = 14;

float selected[15] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

float minX = 100000;
float maxX = -100000;
float minY = 100000;
float maxY = -100000;
float minZ = 100000;
float maxZ = -100000;

void kocka(void) // ova e objektot koj go pretstavuva svetloto
{
	glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);

	glColor3f(1, 1, 1);
	glBegin(GL_QUADS);
	glNormal3f(0, 0, -1); // za sekoj poedinechen poligon mora da se navede vektor
						 // koj e normalen na ramninata na poligonot, za da se znae
						 // vo koj pravec se odbiva svetloto
	glVertex3f(-10,  10, 0);
	glVertex3f( 10,  10, 0);
	glVertex3f( 10, -10, 0);
	glVertex3f(-10, -10, 0);

	glNormal3f(0, 0, 1);
	glVertex3f(-10, -10, 13);
	glVertex3f(-10, 10, 13);
	glVertex3f(10, 10, 13);
	glVertex3f(10, -10, 13);

	glNormal3f(0, -1, 0);
	glVertex3f(-10, -10, 0);
	glVertex3f(-10, -10, 13);
	glVertex3f(10, -10, 13);
	glVertex3f(10, -10, 0);

	glNormal3f(1, 0, 0);
	glVertex3f(10, 10, 0);
	glVertex3f(10, -10, 0);
	glVertex3f(10, -10, 13);
	glVertex3f(10, 10, 13);

	glNormal3f(0, 1, 0);
	glVertex3f(10, 10, 0);
	glVertex3f(10, 10, 13);
	glVertex3f(-10, 10, 13);
	glVertex3f(-10, 10, 0);

	glNormal3f(-1, 0, 0);
	glVertex3f(-10, 10, 0);
	glVertex3f(-10, 10, 13);
	glVertex3f(-10, -10, 13);
	glVertex3f(-10, -10, 0);
	glEnd();
}

void mrezha(int chekori) {
	glBegin(GL_QUADS);
	glNormal3f(0, 0, 1); // edna zaednichka normala za site chetiriagolnici od mrezhata
	float i = 0;
	float j = 0;
	for (i = 0; i < chekori; i++) {
		for (j = 0; j < chekori; j++) {
			glTexCoord2f(i / chekori + 0.0f, j / chekori + 0.0f);
			glVertex3f  (i / chekori + 0.0f, j / chekori + 0.0f, 0);

			glTexCoord2f(i / chekori + 1.0f / chekori, j / chekori + 0.0f);
			glVertex3f  (i / chekori + 1.0f / chekori, j / chekori + 0.0f, 0);

			glTexCoord2f(i / chekori + 1.0f / chekori, j / chekori + 1.0f / chekori);
			glVertex3f  (i / chekori + 1.0f / chekori, j / chekori + 1.0f / chekori, 0);

			glTexCoord2f(i / chekori + 0.0f,           j / chekori + 1.0f / chekori);
			glVertex3f  (i / chekori + 0.0f,           j / chekori + 1.0f / chekori, 0);
		}
	}
	glEnd();
}

void mrezhaPatos(GLenum mode, float chekori) {
	if (mode == GL_RENDER) {
		float mat_ambient[] = { 0.1f, 0.1f, 0.1f, 0.4f };
		float mat_diffuse[] = { 0.9f, 0.9f, 0.9f, 0.4f };
		float mat_specular[] = { 1.0f, 1.0f, 1.0f, 0.4f };
		float mat_shininess = 0.7f;

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
		glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

		glBindTexture(GL_TEXTURE_2D, texParket);
	}

	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
	glLoadIdentity();
	glScalef(4, 4, 4);
	glMatrixMode(GL_MODELVIEW);
	mrezha(7);
	glBindTexture(GL_TEXTURE_2D, 0);
}

void mrezhaTavan(GLenum mode, float chekori) {
	if (mode == GL_RENDER) {
		float mat_ambient[] = { 0.15f, 0.15f, 0.1f, 1.0f };
		float mat_diffuse[] = { 0.9f, 0.9f, 0.9f, 1.0f };
		float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
		float mat_shininess = 0.9f;

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
		glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

		glBindTexture(GL_TEXTURE_2D, 0);
	}

	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
	glLoadIdentity();
	glScalef(4, 4, 4);
	glMatrixMode(GL_MODELVIEW);
	mrezha(7);
	glBindTexture(GL_TEXTURE_2D, 0);
}

void mrezhaKilim(GLenum mode, float chekori) {
	if (mode == GL_RENDER) {
		float mat_ambient[] = { 0.2f, 0.2f, 0.2f, 1.0f };
		float mat_diffuse[] = { 0.9f, 0.9f, 0.9f, 1.0f };
		float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
		float mat_shininess = 0.4f;
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
		glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

		glBindTexture(GL_TEXTURE_2D, texKilim);
		glMatrixMode(GL_TEXTURE);
		glPushMatrix();
		glLoadIdentity();
	}

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	if (selected[selKilim] == 0) {
		glColor3f(20, 20, 20);
	} else {
		glTranslatef(0, 0, 0.01);
		glColor3f(1, 1, 1);
	}
	mrezha(chekori);
	glPopMatrix();
	glBindTexture(GL_TEXTURE_2D, 0);
}

void mrezhaZidSoDrvo(float chekori) {
	glBindTexture(GL_TEXTURE_2D, texDrvo);
	glMatrixMode(GL_TEXTURE);
	glPushMatrix();
	glLoadIdentity();
	glScalef(3, 2, 2);
	glMatrixMode(GL_MODELVIEW);
	mrezha(chekori);
	glBindTexture(GL_TEXTURE_2D, 0);
}

void mrezhaZaZidSoMural(float chekori) {
	glBindTexture(GL_TEXTURE_2D, texNASA);
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();
	glTranslatef(0.5, 0.5, 0);
	glRotatef(rotateNasa, 0, 0, 1);
	glScalef(-1, 1, 1);
	glScalef(1.5, 1.5, 1.5);
	glTranslatef(-0.5, -0.5, 0);
	glMatrixMode(GL_MODELVIEW);
	mrezha(chekori);
	glBindTexture(GL_TEXTURE_2D, 0);
}

void skalilo_bezier(bool shadow, bool reflexion) {
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glScalef(0.1, 0.02, 0.1);
	glRotatef(0, 0, 1, 0);
	GLfloat ctrlPoints[3][3][3] = { { { 0.0f, 0.0f, 0.0f },
			{ 0.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 0.0f } },
			{ { -3.0f, 0.0f, -4.0f }, { 0.0f, 4.0f, -7.0f },
					{ 3.0f, 0.0f, -4.0f } }, { { -4.0f, 0.0f, -10.0f }, { 0.0f,
					0.0f, -10.0f }, { 4.0f, 0.0f, -10.0f } } };
	glMap2f(GL_MAP2_VERTEX_3, 0.0f, 5.0f, 3, 3, 0.0f, 5.0f, 9, 3,
			&ctrlPoints[0][0][0]);
	glEnable(GL_MAP2_VERTEX_3);

	float mat_ambient[] = { 0.1f, 0.1f, 0.1f, 1.0f };
	float mat_diffuse[] = { 0.9f, 0.9f, 0.9f, 1.0f };
	float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	float mat_shininess = 0.3f;

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
	glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

	glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
	if (shadow) {
		glColor4f(0,0,0, alpha);
	} else {
		glColor4f(0.8f, 0.8f, 0.8f, alpha);
	}

	if (reflexion) {
		glNormal3f(0, 1, 0);
	} else {
		glNormal3f(0, -1, 0);
	}
	glMapGrid2f(5, 0.0f, 5.0f, 5, 0.0f, 5.0f);
	glEvalMesh2(GL_FILL, 0, 5, 0, 5);
	glPopMatrix();
}

void patos (GLuint mode) {
	if (selected[selPatos] == 0) {
		glColor4f(1, 1, 1,0.5f);
	} else {
		glColor4f(15, 15, 15,0.5f);
	}
	glPushMatrix();
	glTranslatef(-50, -50, -50);
	glRotatef(90, 1, 0, 0);
	glScalef(100, 100, 100);
	if (mode == GL_SELECT) {
		glLoadName(selPatos);
	}
	mrezhaPatos(mode, 11);
	glPopMatrix();
}

void soba(GLenum mode) {
	if (mode == GL_RENDER) {
		float mat_ambient[] = { 0.1f, 0.1f, 0.1f, 1.0f };
		float mat_diffuse[] = { 0.9f, 0.9f, 0.9f, 1.0f };
		float mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
		float mat_shininess = 0.5f;

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
		glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

		glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
	}

	// eden po eden zidovite od sobata
	if (selected[selMural] == 0) {
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glColor3f(0.5, 0.5, 0.5);
	} else {
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
		glColor3f(50, 50, 50);
	}
	glPushMatrix();
	glRotatef(180, 0, 1, 0);
	glTranslatef(-50, -50, 50);
	glScalef(100, 100, 100);
	if (mode == GL_SELECT) {
		glLoadName(selMural);
	}
	mrezhaZaZidSoMural(11);
	glPopMatrix();
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	//patos(mode);

	if (selected[selTavan] == 0) {
		glColor3f(1, 1, 1);
	} else {
		glColor3f(15, 15, 15);
	}
	glPushMatrix();
	glTranslatef(-50, 50, 50);
	glScalef(100, 100, 100);
	glRotatef(-90, 1, 0, 0);
	if (mode == GL_SELECT) {
		glLoadName(selTavan);
	}
	mrezhaTavan(mode,20);
	glPopMatrix();

	if (selected[selDesen] == 0) {
		glColor3f(0.1f, 0.1f, 1.0f);
	} else {
		glColor3f(15, 15, 15);
	}

	glPushMatrix();
	glRotatef(90, 0, 1, 0);
	glTranslatef(-50, -50, 50);
	glScalef(100, 100, 100);
	if (mode == GL_SELECT) {
		glLoadName(selDesen);
	}
	mrezhaZidSoDrvo(11);
	glPopMatrix();

	if (selected[selLev] == 0) {
		glColor3f(1.0f, 0.2f, 0.0f);
	} else {
		glColor3f(15, 15, 15);
	}

	glPushMatrix();
	glTranslatef(-50, -50, -50);
	glRotatef(-90, 0, 1, 0);
	glScalef(100, 100, 100);
	if (mode == GL_SELECT) {
		glLoadName(selLev);
	}
	mrezhaZidSoDrvo(11);
	glPopMatrix();

	if (selected[selPozadi] == 0) {
		glColor3f(1.0f, 0.2f, 0.0f);
	} else {
		glColor3f(15, 15, 15);
	}

	glPushMatrix();
	glTranslatef(-50, -50, 50);
	glScalef(100, 100, 100);
	if (mode == GL_SELECT) {
		glLoadName(selPozadi);
	}
	mrezhaZidSoDrvo(11);
	glPopMatrix();
}

void skalila(GLenum mode, float chekor, bool shadow, bool reflexion) {
	if (mode == GL_RENDER) {
		float mat_ambient[] = { 0.2f, 0.2f, 0.2f, 1.0f };
		float mat_diffuse[] = { 0.8f, 0.8f, 0.8f, 1.0f };
		float mat_specular[] = { 0.2f, 0.2f, 0.2f, 1.0f };
		float mat_shininess = 0.25;

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
		glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);
	}

	float stepa = 4.0 * M_PI / chekor;
	float stepv = 1.0 / (chekor + 1);
	float a = 0;

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(0, stepv, 0);
	while (a <= 4.0 * M_PI) {
		skalilo_bezier(shadow, reflexion);
		glRotatef(stepa * 180.0 / M_PI, 0, 1, 0);
		glTranslatef(0, stepv, 0);
		a += stepa;
	}
	glPopMatrix();
}

/* procedura za iscrtuvanje na eden stolb so visina 1 i radius 1 (cilindar) */
void stolb(GLenum mode, float chekor, bool shadow) {
	float stepa = 2.0 * M_PI / chekor;
	float a = 0.0;

	if (mode == GL_RENDER) {
		float mat_ambient[] = { 0.2f, 0.2f, 0.2f, 1.0f };
		float mat_diffuse[] = { 0.8f, 0.8f, 0.8f, 1.0f };
		float mat_specular[] = { 0.2f, 0.2f, 0.2f, 1.0f };
		float mat_shininess = 0.25;

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
		glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
		glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

		glBindTexture(GL_TEXTURE_2D, texAluminium);
		glMatrixMode(GL_TEXTURE);
		glLoadIdentity();
	}

	glMatrixMode(GL_MODELVIEW);

	if (shadow) {
		glColor4f(0,0,0,alpha);
	} else {
		glColor4f(1, 1, 1,1);
	}
	glPushMatrix();
	while (!(a > 2.0 * M_PI)) {
		/* slichno kako kaj skalite, no se koristat chetiriagolnici */
		glBegin(GL_QUAD_STRIP);
		for (float i = 0; i <= 1; i += 1 / chekor / 2) {
			glNormal3f(cos(stepa), 0, sin(stepa));
			glTexCoord2f(1, i);
			glVertex3f(cos(stepa), i, sin(stepa));

			glNormal3f(1, 0, 0);
			glTexCoord2f(0, i);
			glVertex3f(1, i, 0);
		}
		glEnd();
		glRotatef(stepa * 180.0 / M_PI, 0, 1, 0);
		a += stepa;
	}
	glPopMatrix();

	glBindTexture(GL_TEXTURE_2D, 0);
}

void kilim (GLuint mode) {
		glPushMatrix();
			glTranslatef(-35, -49.8, 35);
			glScalef(70, 70, 70);
			glRotatef(-90, 1, 0, 0);
			if (mode == GL_SELECT) {
				glLoadName(selKilim);
			}
			if (mode == GL_FEEDBACK)
				glPassThrough(selKilim);
			mrezhaKilim(mode, 10);
		glPopMatrix();
}

void predmetiVoSoba(GLenum mode, bool shadow, bool reflexion) {

	glPushMatrix();
		glTranslatef(-25, -50, -25);
		glScalef(3, 100, 3);
		if (mode == GL_SELECT) {
			glLoadName(selStolb1);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selStolb1);
		stolb(mode, 7, shadow);
		glScalef(5, 1, 5);
		if (mode == GL_SELECT) {
			glLoadName(selSkalila1);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selSkalila1);
		skalila(mode, 10, shadow, reflexion);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-25, -50, 25);
		glScalef(3, 100, 3);
		if (mode == GL_SELECT) {
			glLoadName(selStolb2);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selStolb2);
		stolb(mode, 7, shadow);
		glScalef(5, 1, 5);
		if (mode == GL_SELECT) {
			glLoadName(selSkalila2);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selSkalila2);
		skalila(mode, 10, shadow, reflexion);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(25, -50, 25);
		glScalef(3, 100, 3);
		if (mode == GL_SELECT) {
			glLoadName(selStolb3);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selStolb3);
		glColor3f(1, 1, 1);
		stolb(mode, 7, shadow);
		glScalef(5, 1, 5);
		if (mode == GL_SELECT) {
			glLoadName(selSkalila3);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selSkalila3);
		skalila(mode, 10, shadow, reflexion);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(25, -50, -25);
		glScalef(3, 100, 3);
		if (mode == GL_SELECT) {
			glLoadName(selStolb4);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selStolb4);
		glColor3f(1, 1, 1);
		stolb(mode, 7, shadow);
		glScalef(5, 1, 5);
		if (mode == GL_SELECT) {
			glLoadName(selSkalila4);
		}
		if (mode == GL_FEEDBACK)
			glPassThrough(selSkalila4);
		skalila(mode, 10, shadow, reflexion);
	glPopMatrix();

}

void golemCrnPravoagolnikNamestoSenka(void) {
    glPushAttrib(GL_LIGHTING_BIT);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);

    glColor4f(0,0,0,shadowAlpha);
    glBegin(GL_QUADS);
        glVertex3f(-238,-49.5f,-238);
        glVertex3f( 238,-49.5f,-238);
        glVertex3f( 238,-49.5f,238);
        glVertex3f(-328,-49.5f,238);
    glEnd();

    glEnable(GL_TEXTURE_2D);
    glEnable(GL_LIGHTING);
    glPopAttrib();
}

void crtajSenka(GLfloat svetlo_position[]) {
    // SENKA SE CRTA SO "SPLESKUVACHKA" PROEKCIJA NA OBJEKTITE
    // no namesto istata direktno da se nacrta, se kreira maska od istoto,
    // maska koja ne izleguva nadvor od patosot
    // pa se crta golem crn pravoagolnik niz maskata
    ///////////////////////////////////////////////

    // podgotovka na maska za otsekuvanje na senkite
    glClear(GL_STENCIL_BUFFER_BIT);
    glDisable(GL_DEPTH_TEST);
    glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
    glEnable(GL_STENCIL_TEST);

    // se crtaat pikselite od spleskanite objekti - senkata, no ne na ekran, tuku vo stencilot
    // so toa se formira maska koja ja sodrzhi samo senkata, so vrednost 3
    glStencilFunc(GL_ALWAYS, 3, 0xffffffff);
    glStencilOp(GL_REPLACE, GL_REPLACE, GL_REPLACE);

    // crtanjeto
    //////////////////////////
    glPushAttrib(GL_LIGHTING_BIT);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);
    glPushMatrix();
		 GLfloat shadowMat[4][4];
		 // senkata ja vrzuvame za ramnina niz 3 tochki od ramninata na senkata
		 GLfloat points[3][3] = {  {  0, -49.5f, 10 },
											{ 10, -49.5f, 10 },
											{ 10, -49.5f,  0 } };
		 MakeShadowMatrix(points, svetlo_position, shadowMat);
		 glMultMatrixf((GLfloat *)shadowMat);
		 // objekti vo sobata crtani bez materijali i teksturi zaradi senka
		 predmetiVoSoba(GL_RENDER,true,false);
    glPopMatrix();
    glEnable(GL_TEXTURE_2D);
    glPopAttrib();
    //////////////////////////
    //////////////////////////

    // se crtaat pikselite na patosot, no ne na ekran, tuku vo stencilot, so namaluvanje na vrednosta za 1
    // pa taka kaj shto bilo 3 kje stane 2, a kaj shto bilo 0 kje si ostane 0
    glStencilFunc(GL_ALWAYS, 1, 0xffffffff);
    glStencilOp(GL_DECR, GL_DECR, GL_DECR);
    glEnable(GL_DEPTH_TEST);
    patos(GL_RENDER);

    // potoa ja vkluchuvame maskata
    glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
    // i aktivirame stencil filter da crta samo kaj shto vrednosta e 2 (znachi senkata, vnatre vo patosot)
    glEnable(GL_DEPTH_TEST);
    glStencilFunc(GL_EQUAL, 2, 0xffffffff);
    glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
    golemCrnPravoagolnikNamestoSenka();
    glDisable(GL_STENCIL_TEST);
}

void crtajRefleksija(void) {
    // crtanje na scenata so refleksii
    glPushMatrix();

        //maska za otsekuvanje za refleksijata
        glDisable(GL_DEPTH_TEST);
        glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
        glEnable(GL_STENCIL_TEST);
        glStencilOp(GL_REPLACE, GL_REPLACE, GL_REPLACE);
        glStencilFunc(GL_ALWAYS, 1, 0xffffffff);

        patos(GL_RENDER); 

        glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
        glEnable(GL_DEPTH_TEST);
        glStencilFunc(GL_EQUAL, 1, 0xffffffff);
        glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
            glPushMatrix();
                // objekti vo sobata iscrtani inverzno zaradi refleksija
                glTranslatef(0,-100,0);
                glScalef(1,-1,1);

                glEnable(GL_NORMALIZE);
                glCullFace(GL_FRONT);
                glFrontFace(GL_CW);
                predmetiVoSoba(GL_RENDER,false,true);

                glFrontFace(GL_CCW);
                glCullFace(GL_BACK);
                glDisable(GL_NORMALIZE);
            glPopMatrix();
            patos(GL_RENDER);
            //golemCrnPravoagolnikNamestoSenka();
        glDisable(GL_STENCIL_TEST);
    glPopMatrix();

}

void drawScene(GLenum mode) {
	//Mestenje pogled
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0, 0, transZ, 0, 0, 0, 0, 1, 0);
	glRotatef(rotateA, 0, 1, 0);

	// repozicioniranje na svetloto
	GLfloat svetlo0_position[] = { svX, svY, svZ, 1 };
	glLightfv(GL_LIGHT0, GL_POSITION, svetlo0_position);
	//GLfloat spotdir[]= {0,-20,0};
	//glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,spotdir);
	glPushMatrix();
	glTranslatef(svX, svY, svZ);
	glScalef(0.1, 0.1, 0.1);
	kocka();
	glPopMatrix();

	predmetiVoSoba(mode,false,false);
	
	crtajRefleksija();

	kilim(GL_RENDER);
	
	crtajSenka(svetlo0_position);
	
	soba(mode);
}

void display(void) {
	glPolygonMode(GL_FRONT_AND_BACK, polygonMode);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	drawScene(GL_RENDER);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(0, 800, 0, 600, -1000, 1000);
	glColor3f(1, 0, 0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_QUADS);
		glVertex3f(minX, minY, 0);
		glVertex3f(maxX, minY, 0);
		glVertex3f(maxX, maxY, 0);
		glVertex3f(minX, maxY, 0);
	glEnd();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

	// iscrtaj i smeni buffer
	glutSwapBuffers();
}

void initTextures(void) {
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	//na nekoi instalacii ovie konstanti ne se definirani
	#define GL_CLAMP_TO_EDGE 			0x812D
	#define GL_CLAMP_TO_BORDER			0x812D

	// tekstura kilim - od datoteka
	Image *imageKilim;

	imageKilim = (Image *) malloc(1700000);
	if (imageKilim == NULL) {
		printf("Error allocating space for image");
		exit(0);
	}

	//vnimavajte za providni sliki treba da se koristi ovaa load funkcija
	if (!ImageLoadWithAlpha("kilimt.bmp", imageKilim)) {
		exit(1);
	}

	glGenTextures(1, &texKilim);
	glBindTexture(GL_TEXTURE_2D, texKilim);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_BORDER);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_BORDER);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D, 0, 4, imageKilim->sizeX, imageKilim->sizeY, 0,
	GL_RGBA, GL_UNSIGNED_BYTE, imageKilim->data);

	// tekstura drvo - od datoteka
	Image *imageDrvo;

	imageDrvo = (Image *) malloc(1700000);
	if (imageDrvo == NULL) {
		printf("Error allocating space for image");
		exit(0);
	}

	if (!ImageLoad("drvo1.bmp", imageDrvo)) {
		exit(1);
	}

	glGenTextures(1, &texDrvo);
	glBindTexture(GL_TEXTURE_2D, texDrvo);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, imageDrvo->sizeX, imageDrvo->sizeY, 0,
	GL_RGB, GL_UNSIGNED_BYTE, imageDrvo->data);

	// tekstura parket - od datoteka
	Image *imageParket;

	imageParket = (Image *) malloc(1700000);
	if (imageParket == NULL) {
		printf("Error allocating space for image");
		exit(0);
	}

	if (!ImageLoadWithAlpha("parkett.bmp", imageParket)) {
		exit(1);
	}

	glGenTextures(1, &texParket);
	glBindTexture(GL_TEXTURE_2D, texParket);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, 4, imageParket->sizeX, imageParket->sizeY, 0,
	GL_RGBA, GL_UNSIGNED_BYTE, imageParket->data);

	// tekstura NASA - od datoteka
	Image *imageNASA;

	imageNASA = (Image *) malloc(1700000);
	if (imageNASA == NULL) {
		printf("Error allocating space for image");
		exit(0);
	}

	if (!ImageLoad("NASA.bmp", imageNASA)) {
		exit(1);
	}

	glGenTextures(1, &texNASA);
	glBindTexture(GL_TEXTURE_2D, texNASA);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_BORDER);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_BORDER);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, imageNASA->sizeX, imageNASA->sizeY, 0,
	GL_RGB, GL_UNSIGNED_BYTE, imageNASA->data);

	// tekstura aluminium - od datoteka
	Image *imageAluminium;

	imageAluminium = (Image *) malloc(1700000);
	if (imageAluminium == NULL) {
		printf("Error allocating space for image");
		exit(0);
	}

	if (!ImageLoad("brushed_aluminium2.bmp", imageAluminium)) {
		exit(1);
	}

	glGenTextures(1, &texAluminium);
	glBindTexture(GL_TEXTURE_2D, texAluminium);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_BORDER);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_BORDER);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, imageAluminium->sizeX,
			imageAluminium->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE,
			imageAluminium->data);
}

void initLights(void) {
	glEnable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);

	// globalno svetlo
	GLfloat global_ambient[] = { 0.1f, 0.1f, 0.1f, 1 };
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);

	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

	// Svetlo 0
	glEnable(GL_LIGHT0);
	GLfloat svetlo0_ambient[] = { 0.1f, 0.1f, 0.1f, 1.0f };
	GLfloat svetlo0_diffuse[] = { 30.0f, 30.0f, 30.0f, 1.0f };
	GLfloat svetlo0_specular[] = { 10.0f, 10.0f, 10.0f, 1.0f };
	glLightfv(GL_LIGHT0, GL_AMBIENT, svetlo0_ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, svetlo0_diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, svetlo0_specular);
}

void init(void) {
	glClearColor(0.1f, 0.1f, 0.1f, 1.0f);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-1, 1, -1, 1, 0.76, 1000);

	glEnable(GL_DEPTH_TEST);

	glShadeModel(GL_SMOOTH);

	initLights();

	initTextures();

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}

void processHits(GLint hits, GLuint buffer[]) {
	unsigned int i, j;
	GLuint names, *ptr;

	//printf("hits = %d\n", hits);
	ptr = (GLuint *) buffer;
	for (i = 0; i < hits; i++) { /*  for each hit  */
		names = *ptr;
		printf(" number of names for hit = %d\n", names);
		ptr++;
		float z1 = (float) *ptr / 0x7fffffff;
		printf("   z1 is %g;", z1);
		ptr++;
		float z2 = (float) *ptr / 0x7fffffff;
		printf("   z2 is %g;", z2);
		ptr++;
		for (j = 0; j < names; j++) { /*  for each name */
			GLuint a = *ptr;
			selected[a] = 1 - selected[a];
			printf("   selection: %d\n", a);
			ptr++;
		}
	}
}

void processFeedback3DColorVertex(GLint size, GLint *count, GLfloat *buffer) {
	int i;
	//printf("  ");
	for (i = 0; i < 3; i++) {
		float temp = buffer[size - (*count)];
		//printf("%4.2f ", temp);
		*count = *count - 1;
		if (i == 0) {
			if (temp < minX)
				minX = temp;
			if (temp > maxX)
				maxX = temp;
		}
		if (i == 1) {
			if (temp < minY)
				minY = temp;
			if (temp > maxY)
				maxY = temp;
		}
		if (i == 2) {
			if (temp < minZ)
				minZ = temp;
			if (temp > maxZ)
				maxZ = temp;
		}
	}
}

void processFeedbackBuffer(GLint size, GLfloat *buffer) {
	GLint count;
	GLfloat token;
	GLuint startPrinting = GL_FALSE;

	minX = 100000;
	maxX = -100000;
	minY = 100000;
	maxY = -100000;
	minZ = 100000;
	maxZ = -100000;

	//	printf("================== FEEDBACK ======================\n");
	if (size != -1) {
		count = size;
		while (count) {
			//printf("%d ===\n",size);
			token = buffer[size - count];
			count--;

			if (token == GL_PASS_THROUGH_TOKEN) {
				int token = (int) buffer[size - count];
				if (selected[token] == 1) {
					//printf("GL_PASS_THROUGH_TOKEN  %d\n", token);
					startPrinting = GL_TRUE;
				} else {
					startPrinting = GL_FALSE;
				}
				count--;
			} else if (token == GL_POINT_TOKEN) {
				if (startPrinting) {
					//printf("GL_POINT_TOKEN ");
					//print3DcolorVertex(size, &count, buffer);
				}
			} else if (token == GL_LINE_TOKEN) {
				if (startPrinting) {
					//printf("GL_LINE_TOKEN ");
					processFeedback3DColorVertex(size, &count, buffer);
					//printf(" - ");
					processFeedback3DColorVertex(size, &count, buffer);
				}
			} else if (token == GL_LINE_RESET_TOKEN) {
				if (startPrinting) {
					//printf("GL_LINE_RESET_TOKEN ");
					processFeedback3DColorVertex(size, &count, buffer);
					//printf(" - ");
					processFeedback3DColorVertex(size, &count, buffer);
				}
			} else if (token == GL_POLYGON_TOKEN) {
				int dolzhina = buffer[size - count];
				int ii;
				count--;
				if (startPrinting) {
					//	printf("GL_POLYGON_TOKEN  -->  %d ", dolzhina);
					for (ii = 0; ii < dolzhina; ii++)
						processFeedback3DColorVertex(size, &count, buffer);
					//printf("\n");
				}
			}
		}
	}
//	printf("minX: %4.2f maxX: %4.2f \n", minX, maxX);
//	printf("minY: %4.2f maxY: %4.2f \n", minY, maxY);
//	printf("minZ: %4.2f maxZ: %4.2f \n", minZ, maxZ);
//	printf("==================================================\n");
}

#define BUFSIZE 512

void feedback(void) {
	bool selAny=false;
	for (int i=0; i<16; i++) {
		if(selected[i]==1) {
			selAny=true;
		}
	}
	if (selAny) {
		GLint size;
		GLfloat feedBuffer[150000];
		for (int k = 0; k < 150000; k++)
			feedBuffer[k] = 0;

		glFeedbackBuffer(150000, GL_3D, feedBuffer);
		(void) glRenderMode(GL_FEEDBACK);

		drawScene(GL_FEEDBACK);

		glMatrixMode(GL_PROJECTION);

		size = glRenderMode(GL_RENDER);
		processFeedbackBuffer(size, feedBuffer);
	}
}

void saveScreenShot(void) {
	GLubyte *niza;
	GLint viewport[4];
	glGetIntegerv(GL_VIEWPORT, viewport);
	printf("ekran %d %d\n",viewport[2],viewport[3]);
	int golemina=viewport[2]*viewport[3]*3;
	niza = (GLubyte *) malloc(golemina);
	glReadPixels(0,0,viewport[2],viewport[3],GL_RGB,GL_UNSIGNED_BYTE, niza);
   FILE *file;
	if ((file = fopen("screenshot.data", "w")) == NULL) {
		printf("File Not Found\n");
		exit(0);
	}
	fwrite(niza,golemina,1,file);
	fclose(file);
}

void mouse(int button, int state, int x, int y) {

	GLuint selectBuf[BUFSIZE];
	GLint hits;
	GLint viewport[4];

	if (button != GLUT_LEFT_BUTTON || state != GLUT_DOWN)
		return;

	glGetIntegerv(GL_VIEWPORT, viewport);

	glSelectBuffer(BUFSIZE, selectBuf);
	(void) glRenderMode(GL_SELECT);

	glInitNames();
	glPushName(0);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3] - y), 5.0, 5.0,
			viewport);
	glFrustum(-1, 1, -1, 1, 0.76, 1000);

	drawScene(GL_SELECT);

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glFlush();

	hits = glRenderMode(GL_RENDER);
	processHits(hits, selectBuf);

	//////////// feedback
	feedback();

	glutPostRedisplay();

}

void precrtaj(void) {
	feedback();
	glutPostRedisplay();
}

void keyboard(unsigned char key, int x, int y) {
	printf("%d %f %f %f %f \n", key, svX, svY, svZ, transZ);
	switch (key) {
	case 27:
		exit(0);
		break;
	case 'W':
		transZ += 0.5f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'S':
		transZ -= 0.5f;
		if (transZ < 0)
			transZ = 0;
		precrtaj();  // obnovi go prikazot
		break;
	case 'w':
		transZ += 0.1f;
		precrtaj();  // obnovi go prikazot
		break;
	case 's':
		transZ -= 0.1f;
		if (transZ < 0)
			transZ = 0;
		precrtaj();  // obnovi go prikazot
		break;
	case 'A':
		rotateAspeed += 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'a':
		rotateAspeed += 0.1f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'D':
		rotateAspeed -= 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'd':
		rotateAspeed -= 0.1f;
		precrtaj();  // obnovi go prikazot
		break;
	case '1':
		polygonMode = GL_LINE;
		precrtaj();  // obnovi go prikazot
		break;
	case '2':
		polygonMode = GL_FILL;
		precrtaj();  // obnovi go prikazot
		break;
	case '3':
		rotateNasa++;
		precrtaj();  // obnovi go prikazot
		break;
	case '4':
		rotateNasa--;
		precrtaj();  // obnovi go prikazot
		break;
	case '5':
		alpha -= 0.01f;
		precrtaj();  // obnovi go prikazot
		break;
	case '6':
		alpha += 0.01f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'i':
		svY += 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'k':
		svY -= 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'j':
		svX -= 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'l':
		svX += 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'y':
		svZ += 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'h':
		svZ -= 1.0f;
		precrtaj();  // obnovi go prikazot
		break;
	case 'p':
		saveScreenShot();  // obnovi go prikazot
		break;
	}
}

void idle(void) {
	rotateA += rotateAspeed;
	if (rotateAspeed != 0)
		feedback();
	glutPostRedisplay();
}

int main(int argc, char** argv) {
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_ALPHA | GLUT_STENCIL);
	glutInitWindowSize(800, 600);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("Primer");
	init();
	glutDisplayFunc(display);
	glutMouseFunc(mouse);
	glutKeyboardFunc(keyboard);
	glutIdleFunc(idle);
	glutMainLoop();
	return 0;
}
